<?php
namespace FORM4\Form4Teaser\Persistence;

/***************************************************************
 *  Copyright notice
 *
 *  (c) 2014 form4 GmbH & Co. KG <typo3@form4.de>
 *  
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 * @author Stefan Szymanski <stefan.szymanski@form4.de>
 *
 * @package TYPO3
 * @subpackage form4_teaser
 */
class RandomQueryResult extends \FORM4\Form4Pages\Persistence\QueryResult {

	/**
	 * @var boolean Whether the results were already randomized
	 */
	protected $randomized = FALSE;

	/**
	 * Randomizes all elements and then assigns only a fraction of them to the result set.
	 * This breaks pagination.
	 *
	 * @return void
	 */
	protected function initialize() {
		// prepare how many elements the result set should contain
		$limit = intval($this->query->getLimit());
		if (!$limit) {
			$limit = 1000;
		}
		// get the first 1000 elements
		$this->query->setLimit(1000);
		parent::initialize();
		// shuffle all these pages and assign the first ones to the result set
		if (!$this->randomized) {
			shuffle($this->queryResult);
			$this->queryResult = array_slice($this->queryResult, 0, $limit);
			$this->randomized = TRUE;
		}
	}
}