<?php

namespace FORM4\Form4Teaser\Utility;

/***************************************************************
 *  Copyright notice
 *
 *  (c) 2014 form4 GmbH & Co. KG <typo3@form4.de>
 *  
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 * @author stefan.szymanski
 *
 */
class ObjectUtility {
	
	/**
	 * @var \TYPO3\CMS\Extbase\Object\ObjectManager
	 * @inject
	 */
	protected $objectManager;
	
	/**
	 * @param string|callable $callable Either a callable or a string like "className->methodName"
	 * @param array $arguments
	 * @throws \Exception
	 * @return mixed
	 */
	public function callUserFunction($callable, $arguments = array()) {
		if (is_string($callable)) {
			$parts = explode('->', $callable);
			if (count($parts) == 2) {
				$callable = $parts;
			} else {
				throw new \Exception('Wrong format, must be an callable or a string like ClassName->method', 1415266764);
			}
		}
		if (is_array($callable) && is_string($callable[0])) {
			$callable[0] = $this->objectManager->get($callable[0]);
		}
		return call_user_func_array($callable, $arguments);
	}
	
}